//+------------------------------------------------------------------+
//|                                             IndicatorFromCSV.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
//--- input parameters
#include <stdlib.mqh>
extern int       Shift = 0;//
extern string    FileName = "EURUSD.csv"; // 
extern string    DateFormat = "dd.mm.yyyy";

double Buff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,Red);
SetIndexBuffer(0,Buff);
datetime OutDate;
   string date,val;
   int ValShift;
   int    counted_bars=IndicatorCounted();
//----
   int h = FileOpen(FileName,FILE_READ|FILE_CSV,",");
   if(h>0)
   	{
   		ArrayInitialize(Buff,EMPTY_VALUE);
   		FileSeek(h,0,SEEK_SET);
   		ValShift = Shift*Period()*60;
   		while(!FileIsEnding(h))
   			{
   			date = FileReadString(h);
   			val = FileReadString(h);
   			OutDate = StrToTime(date) + ValShift;
   			//Print(TimeToStr(OutDate,TIME_DATE|TIME_MINUTES));
   			Buff[iBarShift(NULL,0,OutDate)] = StrToDouble(val);
   			}
   			FileClose(h);
   	}
   	//FileDelete(FileName);
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   /*
   datetime OutDate;
   string date,val;
   int ValShift;
   int    counted_bars=IndicatorCounted();
//----
   int h = FileOpen(FileName,FILE_READ|FILE_CSV,",");
   if(h>0)
   	{
   		ArrayInitialize(Buff,EMPTY_VALUE);
   		FileSeek(h,0,SEEK_SET);
   		ValShift = Shift*Period()*60;
   		while(!FileIsEnding(h))
   			{
   			date = FileReadString(h);
   			val = FileReadString(h);
   			OutDate = StrToTime(date) + ValShift;
   			//Print(TimeToStr(OutDate,TIME_DATE|TIME_MINUTES));
   			Buff[iBarShift(NULL,0,OutDate)] = StrToDouble(val);
   			}
   			FileClose(h);
   	}
   	//FileDelete(FileName);
//----
*/
   return(0);
  }
  
//+------------------------------------------------------------------+
bool IsNumeric(string c)
{
   int i=StringGetChar(c,0);
   return(i>=48&&i<=57);
}

datetime StrToDate(string src, string format)
{
   src=StringTrimLeft(StringTrimRight(src));
   format=StringTrimLeft(StringTrimRight(format));
   
   string sy="",sm="",sd="",sh="",si="";
   int pos=0,cv;
   string c,p;
   while(pos<StringLen(src))
   {
      c=StringSubstr(src,pos,1);
      p=StringSubstr(format,pos,1);
      
      if(p=="y")
      {
        if(IsNumeric(c)) sy=sy+c;
        else return(0);
      }
      else
      if(p=="m")
      {
        if(IsNumeric(c)) sm=sm+c;
        else return(0);
      }
      else
      if(p=="d")
      {
        if(IsNumeric(c)) sd=sd+c;
        else return(0);
      }  
      else
      if(p=="h")
      {
        if(IsNumeric(c)) sh=sh+c;
        else return(0);
      }
      else
      if(p=="i")
      {
        if(IsNumeric(c)) si=si+c;
        else return(0);
      }
      else 
      if(p!=c) return(0);
      pos++;
   }   
   string result;
   if(sy!=""&&sm!=""&&sd!="") result=StringConcatenate(sy,".",sm,".",sd);
   if(sh!=""&&si!="") result=StringConcatenate(result," ",sh,":",si);
   	Print(" "+result);
   return(StrToTime(result));
}